package org.codehaus.mojo.fitnesse;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on fitnesse-maven-plugin.<br/> Call <pre>  mvn fitnesse:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Thu Sep 13 19:26:27 CEST 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:fitnesse-maven-plugin:1.1-beta-1", 0 );
        append( sb, "", 0 );

        append( sb, "FitNesse Maven Plugin", 0 );
        append( sb, "The Codehaus is a collaborative environment for building open source projects with a strong emphasis on modern languages, focussed on quality components that meet real world needs.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 4 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "fitnesse".equals( goal ) )
        {
            append( sb, "fitnesse:fitnesse", 0 );
            append( sb, "Generates a FitNesse report from a FitNesse web server. The generated report is an external report generated FitNesse itself. If the project use Clover for code coverage and if FitNesse has clover dependency (ie use the ArtifactId-Version-clover.jar), the code executed during the FitNesse execution (phase integration-test) will be had to the unit-test code coverage. See the clover example.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "fitnesseOutputDirectory", 2 );
                append( sb, "The directory where the Fitnesse report has be generated. It must be defined when it\'s not the default value (${project.build.directory}/fitnesse. It\'s the case for exemple with the clover plugin (that use ${project.build.directory}/clover/fitnesse).", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory", 2 );
                append( sb, "The directory where the Fitnesse report will be generated.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project.reporting.outputDirectory}/fitnesse", 3 );
                append( sb, "", 0 );

                append( sb, "workingDir", 2 );
                append( sb, "Working directory", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project.build.directory}", 3 );
                append( sb, "", 0 );

                append( sb, "xmlOutputDirectory", 2 );
                append( sb, "Report output directory. It should be defined in the reporting section of the pom.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project.build.directory}/generated-site/xdoc/fitnesse", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "fitnesse:help", 0 );
            append( sb, "Display help information on fitnesse-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0fitnesse:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "remotecall".equals( goal ) )
        {
            append( sb, "fitnesse:remotecall", 0 );
            append( sb, "This goal uses the fitnesse.runner.TestRunner class for getting result of a remote FitNesse web page execution. It\'s possible to define several pages and/or servers.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cmdFitnesseHostName", 2 );
                append( sb, "Similar to the fitnesse configuration, but this parameter allow to override all the fitnesse by passing this parameter in the command line. FitnesseAbstractMojo.fitnesses", 3 );
                append( sb, "Expression: ${fitnesse.hostName}", 3 );
                append( sb, "", 0 );

                append( sb, "cmdFitnessePage", 2 );
                append( sb, "Similar to the fitnesse configuration, but this parameter allow to override all the fitnesse by passing this parameter in the command line. FitnesseAbstractMojo.fitnesses", 3 );
                append( sb, "Expression: ${fitnesse.page}", 3 );
                append( sb, "", 0 );

                append( sb, "cmdFitnessePort", 2 );
                append( sb, "Similar to the fitnesse configuration, but this parameter allow to override all the fitnesse by passing this parameter in the command line. FitnesseAbstractMojo.fitnesses", 3 );
                append( sb, "Expression: ${fitnesse.port}", 3 );
                append( sb, "", 0 );

                append( sb, "cmdFitnesseSuiteFilter", 2 );
                append( sb, "Similar to the fitnesse configuration, but this parameter allow to override all the fitnesse by passing this parameter in the command line. FitnesseAbstractMojo.fitnesses", 3 );
                append( sb, "Expression: ${fitnesse.suiteFilter}", 3 );
                append( sb, "", 0 );

                append( sb, "dateFormat (Default: dd/MM/yyyy HH:mm)", 2 );
                append( sb, "Date format for FitNesse page timestamp.", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: false)", 2 );
                append( sb, "Fail the build if fitnesse pages have error.", 3 );
                append( sb, "", 0 );

                append( sb, "fitnesses", 2 );
                append( sb, "This is the list of FitNesse server pages.\nA FitNesse tag is compose of the nested tags:\n<fitnesses>\n\u00a0<fitnesse>\n\u00a0\u00a0<pageName>This is the only required parameter, the name of the FitNesse page</pageName>\n\u00a0\u00a0<hostName>default is locahost</hostName>\n\u00a0\u00a0<port>: default is 80</port>\n\u00a0\u00a0<serverId>ServerId defined in your settings.xml, this allows to use credentials (basic athentification) for calling your FitNesse pages</serverId>\n\u00a0\u00a0<type>Override the default type of the page (Suite or Test)</type>\n\u00a0\u00a0<suiteFilter>Allow the use of Suite filtering ( TestSuites )</suiteFilter>\n\u00a0</fitnesse>\n...\n</fitnesses>:\n", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "run".equals( goal ) )
        {
            append( sb, "fitnesse:run", 0 );
            append( sb, "This goal uses the fitnesse.runner.TestRunner class for calling a remote FitNesse web page and executes the tests or suites locally into a forked JVM. It\'s possible to define several pages and/or servers.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classPathProvider (Default: fitnesse)", 2 );
                append( sb, "This property defines how the plugin will create the classpath for running fixtures. It accepts a couple of value: \'fitnesse\' (default) or \'maven\'.\nWith \'fitnesse\' mode, the classpath is downloaded from the FitNesse server page. Then classpath of the plugin is appended (for providing the good FitNesse implementation).\nWith \'maven\' mode the classpath is only defined with the one of the project (POM).", 3 );
                append( sb, "", 0 );

                append( sb, "classPathSubstitutions", 2 );
                append( sb, "List of Classpath substitution. Substitutions allow to change the FitNesse class path.\nIt should be usefull when the server classpath is in a Unix syntaxe, or when libs are not located in the same folder on the server and on the developer desktop.\nThe order of substitutions is guaranteed to be the same than the definition.\nThe substitutions use String replacements (not patterns). <classPathSubstitutions>\n\u00a0\u00a0<classPathSubstitution>\n\u00a0\u00a0\u00a0\u00a0<search>The key that will be replace</search>\n\u00a0\u00a0\u00a0\u00a0<replaceWith>The value that should use to replace the key</replaceWith>\n\u00a0\u00a0</classPathSubstitution>\n\u00a0\u00a0...\n</classPathSubstitutions>:\nThis parameter can only be use if param classPathProvider has fitnesse value.", 3 );
                append( sb, "", 0 );

                append( sb, "cmdFitnesseHostName", 2 );
                append( sb, "Similar to the fitnesse configuration, but this parameter allow to override all the fitnesse by passing this parameter in the command line. FitnesseAbstractMojo.fitnesses", 3 );
                append( sb, "Expression: ${fitnesse.hostName}", 3 );
                append( sb, "", 0 );

                append( sb, "cmdFitnessePage", 2 );
                append( sb, "Similar to the fitnesse configuration, but this parameter allow to override all the fitnesse by passing this parameter in the command line. FitnesseAbstractMojo.fitnesses", 3 );
                append( sb, "Expression: ${fitnesse.page}", 3 );
                append( sb, "", 0 );

                append( sb, "cmdFitnessePort", 2 );
                append( sb, "Similar to the fitnesse configuration, but this parameter allow to override all the fitnesse by passing this parameter in the command line. FitnesseAbstractMojo.fitnesses", 3 );
                append( sb, "Expression: ${fitnesse.port}", 3 );
                append( sb, "", 0 );

                append( sb, "cmdFitnesseSuiteFilter", 2 );
                append( sb, "Similar to the fitnesse configuration, but this parameter allow to override all the fitnesse by passing this parameter in the command line. FitnesseAbstractMojo.fitnesses", 3 );
                append( sb, "Expression: ${fitnesse.suiteFilter}", 3 );
                append( sb, "", 0 );

                append( sb, "copyDependencies (Default: false)", 2 );
                append( sb, "Use shorter classpath. On Windows, the Win32 api doesn\'t allow to create a process via CMD.EXE that contains more than 8192 chars. When fitnesse-maven-plugin calls the page, the classpath that refers to the maven repository may easilly contains more than 8192 chars. see article Activating this property ask the plugin to copy all the dependency in the target folder. This may create an overhead but decrease the classpath size. For exemple the string [E:/Maven/repository/org/springframework /spring-beans/1.2.8/spring-beans-1.2.8.jar] (81 chars) became [lib/spring-beans-1.2.8.jar] (26 chars). That doesn\'t solve the problems but allows to use bigger classpath.", 3 );
                append( sb, "", 0 );

                append( sb, "dateFormat (Default: dd/MM/yyyy HH:mm)", 2 );
                append( sb, "Date format for FitNesse page timestamp.", 3 );
                append( sb, "", 0 );

                append( sb, "debug (Default: false)", 2 );
                append( sb, "Run FitnesseRunner with debug option.", 3 );
                append( sb, "", 0 );

                append( sb, "displayOutput (Default: false)", 2 );
                append( sb, "Redirect FitNesse output into Maven2 log.", 3 );
                append( sb, "", 0 );

                append( sb, "failOnError (Default: false)", 2 );
                append( sb, "Fail the build if fitnesse pages have error.", 3 );
                append( sb, "", 0 );

                append( sb, "fitnesseRunnerClass (Default: fitnesse.runner.TestRunner)", 2 );
                append( sb, "Fitnesse runner class.", 3 );
                append( sb, "", 0 );

                append( sb, "fitnesses", 2 );
                append( sb, "This is the list of FitNesse server pages.\nA FitNesse tag is compose of the nested tags:\n<fitnesses>\n\u00a0<fitnesse>\n\u00a0\u00a0<pageName>This is the only required parameter, the name of the FitNesse page</pageName>\n\u00a0\u00a0<hostName>default is locahost</hostName>\n\u00a0\u00a0<port>: default is 80</port>\n\u00a0\u00a0<serverId>ServerId defined in your settings.xml, this allows to use credentials (basic athentification) for calling your FitNesse pages</serverId>\n\u00a0\u00a0<type>Override the default type of the page (Suite or Test)</type>\n\u00a0\u00a0<suiteFilter>Allow the use of Suite filtering ( TestSuites )</suiteFilter>\n\u00a0</fitnesse>\n...\n</fitnesses>:\n", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "generateXml (Default: false)", 2 );
                append( sb, "Generate Xml file with results. Needed for integrating with CruiseControl", 3 );
                append( sb, "", 0 );

                append( sb, "jdk (Default: java)", 2 );
                append( sb, "Java executable.", 3 );
                append( sb, "", 0 );

                append( sb, "jdkOpts", 2 );
                append( sb, "Jvm arguments.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
